package ca.ualberta.cs.shamooshak;

class MiddlePredictor extends Predictor
{
  void predict(double[][] output, int[][] action, int actionCounter)
  {
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 12; j++)
        output[i][j] = 0.0D;
    if (actionCounter == 0)
      return;
    for (int i = 0; i < 2; i++) {
      int max = Math.max(action[(actionCounter - 1)][2], action[(actionCounter - 1)][(1 - i)]);
      int min = Math.min(action[(actionCounter - 1)][2], action[(actionCounter - 1)][(1 - i)]);
      if (max - min == 6) {
        output[i][((action[(actionCounter - 1)][2] + 3) % 12)] += 0.5D;
        output[i][((action[(actionCounter - 1)][2] + 9) % 12)] += 0.5D;
      } else {
        int midmid = max + min;
        if (max - min < 6)
          midmid = (midmid + 12) % 24;
        int x = midmid / 2;
        int y = (midmid - x) % 12;
        output[i][x] += 0.5D;
        output[i][y] += 0.5D;
      }
    }
  }
}