package lemonade;


/**
 * An action object, used to sort the actions inside of LemonadeUtility.
 * @author maz
 */
public class Action implements Comparable<Action>{

  /**
   * The player taking the action.
   */
  public int player;

  
  /**
   * The position (or action) the player is taking
   */
  public int position;
  public Action(int player, int position) {
    this.player = player;
    this.position = position;
  }
  

  public int compareTo(Action arg0) {
    return position-arg0.position;
  }
  
  @Override
  public String toString(){
    return "("+player+","+position+")";
  }
}
