package com.yahoo.lsg.lifelong;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.yahoo.lsg.lifelong.DoubleRandomVariable;

public class DoubleRandomVariableTest {
  DoubleRandomVariable v;
  @Before
  public void setUp() throws Exception {
    v = new DoubleRandomVariable();
    for(int i=0;i<100;i++){
      v.add(1);
      v.add(-1);
    }
  }

  @After
  public void tearDown() throws Exception {
    v = null;
  }


  @Test
  public void testGetMean() {
    double result = v.getMean();
    assertEquals(0.0,result,0.001);
  }

  @Test
  public void testGetStandardErrorOfTheMean() {
    double result = v.getStandardErrorOfTheMean();
    assertEquals(0.0707,result,0.01);
  }

}
