package com.yahoo.lsg.lifelong;

import static org.junit.Assert.*;
import lemonade.GeneralizedLemonadeGameGenerator;
import game.Game;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.yahoo.lsg.lifelong.LifelongMatchup;
import com.yahoo.lsg.lifelong.PlayerIdentity;

import game.GameGenerator;

public class LifelongMatchupTest {

  @Before
  public void setUp() throws Exception {
  }

  @After
  public void tearDown() throws Exception {
  }

  @Test
  public void testLifelongMatchup() throws SecurityException, ClassNotFoundException, NoSuchMethodException {
    final PlayerIdentity[] records = new PlayerIdentity[3];
    for(int i=0;i<3;i++){
      records[i]=new PlayerIdentity("com.yahoo.lifelong.examples.ConstantLifelongStrategy", "");
    }
    final LifelongMatchup matchup = new LifelongMatchup(records);
    assertNotNull(matchup);
  }

  public static int getUtility(Game g, int i, int j, int k){
    final int[] utils = g.getUtility().getUtility(new int[]{i,j,k});
    int total = 0;
    for(int util:utils){
      total+=util;
    }
    return total;
  }
  
  @Test
  public void testPlayMatch() {
    final GameGenerator generator = new GeneralizedLemonadeGameGenerator(0);
    final Game game = generator.getNextGame();
    int numPlayers = game.getNumPlayers();
    int numActions = game.getNumActions();
    assertEquals("This test is not functioning properly",3,numPlayers);
    
    int initialTotal = getUtility(game,0,0,0);
    
    for(int i=0;i<numActions;i++){
      for(int j=0;j<numActions;j++){
        for(int k=0;k<numActions;k++){
          int total = getUtility(game,i,j,k);
          assertEquals("Not equal on position "+i+","+j+","+k,initialTotal,total);
        }
      }
    }
  }
}
