package ca.ualberta.cs.shamooshak;

class BestResponsePredictor extends Predictor
{
  void predict(double[][] output, int[][] action, int actionCounter)
  {
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 12; j++)
        output[i][j] = 0.0D;
    if (actionCounter == 0)
      return;
    for (int i = 0; i < 2; i++) {
      int dist = (action[(actionCounter - 1)][2] + 12 - action[(actionCounter - 1)][(1 - i)]) % 12;
      if (dist < 6)
        for (int j = (action[(actionCounter - 1)][2] + 1) % 12; j != action[(actionCounter - 1)][(1 - i)]; j = (j + 1) % 12)
          output[i][j] = (1.0D / (11 - dist));
      else if (dist > 6)
        for (int j = (action[(actionCounter - 1)][(1 - i)] + 1) % 12; j != action[(actionCounter - 1)][2]; j = (j + 1) % 12)
          output[i][j] = (1.0D / (dist - 1));
      else
        for (int j = 0; j < 12; j++)
          output[i][j] = 0.08333333333333333D;
    }
  }
}