package com.yahoo.lsg.lifelong.observer;

import com.yahoo.lsg.lifelong.PlayerIdentity;

import game.Game;


/**
 * The contract of this interface also involves having a 
 * constructor with the signature (GameInformation, PlayerIdentity ...identities)
 * @author maz
 *
 */
public interface LifelongObserver {
  public void newGame(Game g,PlayerIdentity ...identities);
  public void observeOutcome(int[] actions);
  public void endLifetime();
  
  public void display();
}
