package human;

/**
 * A listener that handles a change in the model. No listener is allowed
 * to obtain any locks while handling this change (calling getModel does not
 * technically obtain a lock).
 * @author maz
 *
 */
public interface HumanModelListener {
  /**
   * A listener that handles a change in the model. No listener is allowed
   * to obtain any locks while handling this change (calling getModel does not
 * technically obtain a lock).
   * @author maz
   */
  public void handleChange(HumanModel model);
}
